Download it now!
Bug 105600 - Allow selecting contents of sections via Navigator
Summary: Allow selecting contents of sections via Navigator
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: All All
: medium enhancement
Assignee: Jim Raykowski
URL:
Whiteboard: target:7.0.0
Keywords:
Depends on:
Blocks: Navigator
  Show dependency treegraph
 
Reported: 2017-01-29 18:59 UTC by C
Modified: 2020-03-26 22:20 UTC (History)
4 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description C 2017-01-29 18:59:55 UTC
This enhancement is closely related to (Bug 63967, Bug 42787) and I presume that the central planning for solving them would be shared.

I would like to be able to select a whole section of my document (for, say, direct formatting, language selection, word count) via the NAVIGATOR.

I preferred to frame it as enhancement, although when trying to select a whole set of pages where there are footnotes, they sometimes interfere. Therefore selecting in NAVIGATOR would be very clean Ux enhancement.





Bug 63967 - Ability to Quickly Get Word Count of Sections Using Navigator 

Bug 42787 - Functionality request for Writer: Add deleting of Sections using the Delete function inside of the Navigator
Comment 1 Buovjaga 2017-02-01 11:55:28 UTC
Ok, let's set to NEW.
Comment 2 Heiko Tietze 2017-02-18 11:18:42 UTC
Navigator enhancement was proposed at https://design.blog.documentfoundation.org/2016/07/31/how-the-navigator-may-support-object-handling-in-libreoffice-draw/ (it's not only Draw what benefits from a fully interactive Navigator), and in bug 56498 and bug 95407. It's also an idea for a GSoC'17 project.
Comment 3 Jim Raykowski 2020-02-02 06:44:33 UTC
Setting to resolved by merge made for bug 128814
Comment 4 sdc.blanco 2020-02-03 14:44:45 UTC
From Navigator, right-click on Section name, choose "Select", entire section is selected.

Tested with:

Version: 7.0.0.0.alpha0+ (x64)
Build ID: dfd027342e6b4107ebd3369de96ef2be3883724d
CPU threads: 8; OS: Windows 10.0 Build 18363; UI render: GL; VCL: win; 
Locale: en-US (en_DK); UI-Language: en-US
Calc: CL
Comment 5 sdc.blanco 2020-02-06 01:05:44 UTC
(In reply to Jim Raykowski from comment #3)
> Setting to resolved by merge made for bug 128814
I won't reopen or remove "verified" on this bug - but here is a special case that I assume you will not like. (wasn't looking for it -- just arose from "normal" use).

1.  Make a section from top of document (with headings in the section)
2.  Make Table of Contents (at top of document)
3.  Use navigator (right-click) to "select" section.

Actual result:  

only selects the "title" of the Table of contents 

Additional information.  

1.  No problem to select another section in the document.
2.  If the table of contents is removed, then no problem to select the entire section.
3.  Did not test to see if the critical feature was "index at top of section" or "index when section is top of document" 

Version: 7.0.0.0.alpha0+ (x64)
Build ID: dfd027342e6b4107ebd3369de96ef2be3883724d
Comment 6 Jim Raykowski 2020-02-06 08:43:43 UTC
@sdc.blanco, It would be great if you can attach an example document.
Comment 7 Jim Raykowski 2020-02-06 08:52:04 UTC
(In reply to Jim Raykowski from comment #6)
> @sdc.blanco, It would be great if you can attach an example document.

No example document required. I read the help document on how to create a table of contents. So easy. I repro your finding. Will see what I can do about it.
Comment 8 Jim Raykowski 2020-02-12 03:32:26 UTC
Same happens as in Comment 5 with Menu > Edit > Select All when cursor is in section containing the TOX. Also, neither Navigator nor Menu > Edit > Select All section selection work properly if a table is the first content in the document.
Comment 9 sdc.blanco 2020-02-13 12:15:09 UTC
(In reply to Jim Raykowski from comment #8)
> Same happens as in Comment 5 with Menu > Edit > Select All when cursor 
> is in section containing the TOX.
Variations on the comment 5 theme.  No conclusions - but maybe interesting for you.

Variation #1

1. Place cursor manually in the "title" of the TOC, 
2. Press Ctrl-A.

Result:  only selects title of TOC

Variation #2

3.  Press Crtl-A again.

Result:  everything is selected (also title!)

Variation #3 

1. Place cursor not in title (e.g., in the middle of the entries in the TOC, even though it is write protected).
2. Press Ctrl-A 

Result: selects the section and TOC, including the Title!

Variation #4

1. Edit index; remove title (i.e., empty "Title" field in Index dialog box)
2. From Navigator, right-click (on Section) and choose "Select"

Result:  entire TOC selected -- but not rest of section 

Variation #5
(again with titleless TOC)

1. Place cursor inside TOC
2. Press Ctrl-A

Result:  entire TOC selected -- but not rest of section 

Variation #6
3. Press Ctrl-A again. 

Result: Entire section selected.

Additional information:
1. "double press" (or in this case "double select") technique does not work from Navigator.

2. (there were other strange things with sections and "double Ctrl-A" -- but these are not relevant to the select section from Navigator)
Comment 10 Jim Raykowski 2020-02-14 07:22:14 UTC
(In reply to sdc.blanco from comment #9)
> (In reply to Jim Raykowski from comment #8)
> > Same happens as in Comment 5 with Menu > Edit > Select All when cursor 
> > is in section containing the TOX.
> Variations on the comment 5 theme.  No conclusions - but maybe interesting
> for you.

Thanks! 

I noticed that section select works as expected if at least one line comes before and after a table, TOC, or sub section in a section. Navigator select currently needs content before not to be empty. I have a patch for that. WIP on a fix for the selection issue when these are at the top or bottom of a section.
Comment 11 sdc.blanco 2020-02-14 09:24:42 UTC
(In reply to Jim Raykowski from comment #10)
> I noticed that section select works as expected if at least one line comes
> before and after a table, TOC, or sub section in a section. 
Have encountered this issue with "one line", in relation to sections.
Just for orientation: bug #129331, comment 6. No expectations, but maybe your travels in the section code gives some insight to that issue as well.

(changing status back to NEW, because REOPENED option was not offered.)
Comment 12 sdc.blanco 2020-03-07 14:43:37 UTC
If a section is empty, then using select (from Navigator) selects the entire file.

For example:

1.  Make three sections, with text in each one.

2.  Can confirm with Navigator, right-click on a section and select will select the contents of the section.

3.  Remove all text from a section.

4.  Use Navigator, right-click, select (on the empty section)

Result:  Entire file is selected.

Tested with:

Version: 7.0.0.0.alpha0+ (x64)
Build ID: 10e20a77ce302a0475a661ad1886f2ca83c55f3f
CPU threads: 8; OS: Windows 10.0 Build 18363; UI render: Skia/Vulkan; VCL: win;
Comment 13 Jim Raykowski 2020-03-08 00:51:59 UTC
(In reply to sdc.blanco from comment #12)
> If a section is empty, then using select (from Navigator) selects the entire
> file.

Thanks for reporting. I was wondering how long it would be before this was noticed ;-)
Comment 14 Jim Raykowski 2020-03-08 02:26:28 UTC
This seems to work better than just calling the select all function.

https://gerrit.libreoffice.org/c/core/+/90181
Comment 15 Commit Notification 2020-03-14 23:29:02 UTC
Jim Raykowski committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/6f82f5163fdd43ea22958dfb28926c88ed97fa7c

tdf#105600 rework section selection from Navigator

It will be available in 7.0.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 16 Jim Raykowski 2020-03-26 22:20:28 UTC
I've set this back to resolved fixed.

Perhaps, because, the issue with section selection when a table doesn't have paragraph content before or after at the start or end of a section isn't specific to section selection from the Navigator, it can be opened in a new bug report.